#include <libporty/host/time.h>

extern char P_path_sep;

/* === file properties === */

/* TODO: this needs to be autodetected to allow 64-bit */
typedef long int P_filesize_t;

P_filesize_t P_file_size(const char *name);


/* portable stat */
typedef long int P_mode_t;

typedef struct P_stat_s {
	P_mode_t mode;
	int nlink;
	P_filesize_t size;
	P_time_t mtime;
/*	P_dev_t st_dev; */
} P_stat_t;

int P_stat(const char *path, P_stat_t *buff);

/* these fields should be in stat normally, but they are much slower to get
   on some systems and/or we offer to get more detailed info */
int P_fs_owner(const char *path, int *uid, char *name, int namelen);



/* === directory listing === */

/* open a directory for listing files */
void *P_open_dir(const char *dirname);

/* read next file name from an open directory; handle is as returned
   by P_open_dir(); returns NULL if no more entries to be read */
const char *P_read_dir(void *handle);

/* close an open directory; handle is as returned by P_open_dir() */
void P_close_dir(void *handle);

