/* fallback for the case when the P_ math funcitons are used outside of
   PM_ macros; not thread safe, should be avoided

   Options:

   1. single thread
      a. use PM_BEGIN/PM_ERROR/PM_END
      b. use P_log() and manually check PM_errno after the call
   2. multithread
      a. use PM_BEGIN/PM_ERROR/PM_END
      b. use P_log_() with local variable errno, manually check it after the call

   Doesn't protect against 1/0 - use P_divf() for secure division.
*/

extern int PM_errno;

#define P_EFPE -1234

#define PM_BEGIN \
	{ \
		int PM_errno = 0; \

#define PM_ERROR \
		; \
		if (PM_errno != 0)

#define PM_END \
		;\
	} \

#define PM_ENDERR(errhandling) \
		; \
		if (PM_errno != 0) { errhandling ; } \
	}


double P_log_(double x, int *perrno);
double P_log(double x);

#define P_log(x)      P_log_(x, &PM_errno)
#define P_divf(x, y)  P_divf_(x, y, &PM_errno)
