/*
    libporty - network uninit chains
    Copyright (C) 2012  Tibor 'Igor2' Palinkas

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

    Project page: http://repo.hu/projects/libporty
    Contact (email and IRC): http://igor2.repo.hu/contact.html
*/

#include <stdlib.h>
#include "uninit_chain.h"

P_net_uninit_t *P_net_uninits = NULL;

void P_net_uninit_chain(void)
{
	P_net_uninit_t *u, *next;

	/* walk through the list and call each item then free it */
	for(u = P_net_uninits; u != NULL; u = next) {
		next = u->next;
		u->cb();
		free(u);
	}
	P_net_uninits = NULL;
}

void P_net_uninit_reg(void (*cb)())
{
	P_net_uninit_t *u;

	u = malloc(sizeof(P_net_uninit_t));
	u->cb = cb;
	u->next = P_net_uninits;
	P_net_uninits = u;
}
