#include <stdlib.h>
#include <stdio.h>
#include <libporty/util/buf.h>
#include <string.h>
char *test_in[] = {
	"first line\n",
	"second",
	" line\n",
	"third line",
	"\n\n",
	"fourth line\nfifth line\nsixth line\n",
	"seventh line truncated",
	NULL
};

int main()
{
	P_buf_t *b;
	char **in;
	char *line;
	int len;

	b = P_buf_init("\n");
	for(in = test_in; *in != NULL; in++) {
		P_buf_fill(b, *in);
		while((line = P_buf_getbin(b, &len)) != NULL) {
			printf("-> '%s'/%d\n", line, len);
			P_buf_free(line);
		}
	}
	P_buf_uninit(b);

	printf("===\n");

	b = P_buf_init("\n");
	for(in = test_in; *in != NULL; in++) {
		P_buf_fillbin(b, *in, strlen(*in));
		while((line = P_buf_getbin(b, &len)) != NULL) {
			printf("-> '%s'/%d\n", line, len);
			P_buf_free(line);
		}
	}
	P_buf_uninit(b);

	return 0;
}
